import java.awt.*;
import java.util.Vector;

public class eShop extends java.applet.Applet {

	private List lstAll, lstSel;
	private Button btnGet, btnPutOne, btnPutLine, btnPutAll,
		btnPlus, btnMinus, btnSubmit;
	private Label lblPrice, lblQuant, lblCost, lblTotal,
		lblPriceAll;
	private TextField tfAddres, tfAccount;

	private String goods[];
	private float prices[], total = 0;
	private int nums[];
	private Vector bag;

	public void init () 
	{
		setBackground (Color.white);
		setLayout (null);
		
		goods = new String[10];
		prices = new float[10];
		nums = new int[10];
		for (int i = 0; i < 10; i++) {
			goods[i] = new String ("Good_"+i);
			prices[i] = (float)(.5) + i;
			nums[i] = 0;
		}
		bag = new Vector();

		Color col;
		Label label;
		
		label = new Label ("Goods:");
		label.reshape (0, 0, 150, 20);
		add (label);

		label = new Label ("Bag:");
		label.reshape (250, 0, 150, 20);
		add (label);
		
		lstAll = new List();
		for (int i = 0; i < goods.length; i++)
			lstAll.addItem (goods[i]);
		lstAll.reshape (0, 20, 150, 100);
		lstAll.select (0);
		add (lstAll);

		lstSel = new List();
		lstSel.reshape (250, 20, 150, 100);
		add (lstSel);

		btnGet = new Button ("Get >");
		btnGet.reshape (160, 20, 80, 20);
		add (btnGet);

		btnPutOne = new Button ("< Put one");
		btnPutOne.reshape (160, 50, 80, 20);
		add (btnPutOne);

		btnPutLine = new Button ("<< Put line");
		btnPutLine.reshape (160, 75, 80, 20);
		add (btnPutLine);

		btnPutAll = new Button ("<<< Put all");
		btnPutAll.reshape (160, 100, 80, 20);
		add (btnPutAll);

		col = new Color (0, 0, 255);
		label = new Label ("Quant:");
		label.reshape (250, 120, 50, 20);
		label.setForeground (col);
		add (label);

		lblQuant = new Label();
		lblQuant.reshape (300, 120, 80, 20);
		lblQuant.setForeground (col);
		add (lblQuant);

		btnPlus = new Button("+");
		btnPlus.reshape (380, 120, 20, 10);
//		btnPlus.setForeground (col);
		btnPlus.disable();
		add (btnPlus);
		
		btnMinus = new Button("-");
		btnMinus.reshape (380, 130, 20, 10);
//		btnMinus.setForeground (col);
		btnMinus.disable();
		add (btnMinus);

		col = new Color (128, 0, 128);
		label = new Label ("Cost:");
		label.reshape (250, 160, 50, 20);
		label.setForeground (col);
		add (label);

		lblCost = new Label ();
		lblCost.reshape (300, 160, 100, 20);
		lblCost.setForeground (col);
		add (lblCost);

		col = new Color (0, 128, 0);		
		label = new Label ("Price:");
		label.reshape (250, 140, 50, 20);
		label.setForeground (col);
		add (label);

		lblPrice = new Label();
		lblPrice.reshape (300, 140, 100, 20);
		lblPrice.setForeground (col);
		add (lblPrice);

		col = new Color (255, 0, 0);
		label = new Label ("Total:");
		label.reshape (250, 180, 50, 20);
		label.setForeground (col);
		add (label);

		lblTotal = new Label ();
		lblTotal.reshape (300, 180, 100, 20);
		lblTotal.setForeground (col);
		add (lblTotal);

		col = new Color (0, 0, 128);
		label = new Label ("Price:");
		label.reshape (0, 120, 50, 20);
		label.setForeground (col);
		add (label);

		lblPriceAll = new Label ();
		lblPriceAll.reshape (50, 120, 100, 20);
		lblPriceAll.setText ("" + prices[0] + " $");
		lblPriceAll.setForeground (col);
		add (lblPriceAll);

		col = new Color (0, 128, 128);
		label = new Label ("Addres:");
		label.reshape (0, 150, 70, 20);
//		label.reshape (0, 145, 70, 20);
		label.setForeground (col);
		add (label);
		
		tfAddres = new TextField();
		tfAddres.reshape (70, 150, 170, 20);
//		tfAddres.reshape (70, 145, 170, 25);
		tfAddres.setForeground (col);
		add (tfAddres);

		label = new Label ("Account:");
		label.reshape (0, 180, 70, 20);
//		label.reshape (0, 175, 70, 20);
		label.setForeground (col);
		add (label);

		tfAccount = new TextField();
		tfAccount.reshape (70, 180, 170, 20);
//		tfAccount.reshape (70, 175, 170, 25);
		tfAccount.setForeground (col);
		add (tfAccount);

		btnSubmit = new Button ("Submit");
		btnSubmit.reshape (150, 210, 100, 30);
		add (btnSubmit);

		enableBagButtons (false);
	}

	public boolean handleEvent (Event evt) 
	{
		switch (evt.id) {
		case Event.LIST_SELECT:
			if (evt.target == lstSel) {
				showBagData ();
				return true;
			}
			if (evt.target == lstAll) {
				int i = lstAll.getSelectedIndex();
				lblPriceAll.setText ("" + prices[i] + " $");
				return true;
			}
		}
		
		return super.handleEvent (evt);
	}

	public boolean action (Event evt, Object what)
	{
		if (evt.target == btnGet) {
			int i = lstAll.getSelectedIndex();
			if (nums[i] == 0) {
				bag.addElement (new Integer (i));
				lstSel.addItem (lstAll.getSelectedItem());
				lstSel.makeVisible (lstSel.countItems() - 1);
			}
			lstSel.select (bag.indexOf (new Integer (i)));
			if (total == 0) enableBagButtons (true);
			nums[i]++;
			total += prices[i];
			showBagData();
			return true;
		}

		if (evt.target == btnPutOne) {
			int iSel = lstSel.getSelectedIndex();
			int i = ((Integer)bag.elementAt (iSel)).intValue();
			total -= prices[i];
			if (total == 0) enableBagButtons (false);
			nums[i]--;
			if (nums[i] == 0) {
				bag.removeElementAt (iSel);
				lstSel.delItem (iSel);
			}
			showBagData();
			return true;
		}

		if (evt.target == btnPutLine) {
			int iSel = lstSel.getSelectedIndex();
			int i = ((Integer)bag.elementAt (iSel)).intValue();
			total -= prices[i] * nums[i];
			if (total == 0) enableBagButtons (false);
			nums[i] = 0;
			bag.removeElementAt (iSel);
			lstSel.delItem (iSel);
			showBagData();
			return true;
		}

		if (evt.target == btnPutAll) {
			total = 0;
			enableBagButtons (false);
			for (int i = 0; i < nums.length; i++)
				nums[i] = 0;
			bag.removeAllElements();
			lstSel.delItems (0, lstSel.countItems() - 1);
			showBagData();
			return true;
		}

		if (evt.target == btnPlus) {
			int iSel = lstSel.getSelectedIndex();
			int i = ((Integer)bag.elementAt (iSel)).intValue();
			total += prices[i];
			nums[i]++;
			showBagData();
			return true;
		}

		if (evt.target == btnMinus) {
			int iSel = lstSel.getSelectedIndex();
			int i = ((Integer)bag.elementAt (iSel)).intValue();
			if (nums[i] > 1) {
				total -= prices[i];
				nums[i]--;
				showBagData();
			}
			return true;
		}

		return false;	
	}
	
	private void showBagData ()
	{
		int iSel = lstSel.getSelectedIndex();
		if (iSel == -1) {
			lblQuant.setText ("");
			lblCost.setText ("");
			lblPrice.setText ("");
			lblTotal.setText ("" + total + " $");
			return;
		}
		int i = ((Integer)bag.elementAt (iSel)).intValue();
		lblQuant.setText ("" + nums[i]);
		lblCost.setText ("" + (prices[i] * nums[i]) + " $");
		lblPrice.setText ("" + prices[i] + " $");
		lblTotal.setText ("" + total + " $");
	}

	private void enableBagButtons (boolean b)
	{
		btnPutOne.enable (b);
		btnPutLine.enable (b);
		btnPutAll.enable (b);
		btnPlus.enable (b);
		btnMinus.enable (b);
		btnSubmit.enable (b);
	}

}